/**
 * Copyright (c) 2003, Xith3D Project Group
 * All rights reserved.
 *
 * Portions based on the Java3D interface, Copyright by Sun Microsystems.
 * Many thanks to the developers of Java3D and Sun Microsystems for their
 * innovation and design.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * Neither the name of the 'Xith3D Project Group' nor the names of its contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */

import java.awt.*;
import com.magicosm.skins.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * Insert package comments here
 * <p/>
 * Originally Coded by David Yazel on Dec 15, 2003 at 11:04:01 PM.
 */
public class TestFrame extends SkinFrame {
    SkinRaisedPanel skinRaisedPanel1 = new SkinRaisedPanel();
    SkinInternalPanel skinInternalPanel1 = new SkinInternalPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    SkinButton skinButton1 = new SkinButton();
    SkinSmallPrompt skinSmallPrompt1 = new SkinSmallPrompt();
    JTextField jTextField1 = new JTextField();
    Border border1;
    SkinTabbedPane skinTabbedPane1 = new SkinTabbedPane();
    JPanel jPanel1 = new SkinPanel();
    JPanel jPanel2 = new SkinPanel();
    SkinCheckBox skinCheckBox1 = new SkinCheckBox();
    SkinCheckBox skinCheckBox2 = new SkinCheckBox();
    SkinCheckBox skinCheckBox3 = new SkinCheckBox();
    SkinScrollPane skinScrollPane1 = new SkinScrollPane();
    BorderLayout borderLayout2 = new BorderLayout();
    JList jList1 = new JList();

    public TestFrame() {
        try {
            jbInit();
            jList1.setListData(new String[] {
                "this is an entry",
                "this is another",
                "and again",
                "you can scroll this list",
                "as far down as you want"
            });

            skinScrollPane1.getVerticalScrollBar().addAdjustmentListener(new AdjustmentListener() {
                    public void adjustmentValueChanged(AdjustmentEvent e) {
                        skinScrollPane1.repaint();
                    }
                });

        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        border1 = BorderFactory.createEmptyBorder(2,6,2,6);
        this.setLayout(borderLayout1);
        skinInternalPanel1.setPreferredSize(new Dimension(10, 40));
        skinRaisedPanel1.setBorder(border1);
        skinRaisedPanel1.setPreferredSize(new Dimension(10, 40));
        skinRaisedPanel1.setLayout(null);
        skinButton1.setPreferredSize(new Dimension(60, 25));
        skinButton1.setText("Exit");
        skinButton1.addActionListener(new TestFrame_skinButton1_actionAdapter(this));
        skinSmallPrompt1.setText("Edit here:");
        skinSmallPrompt1.setBounds(new Rectangle(15, 13, 55, 16));
        jTextField1.setText("");
        jTextField1.setBounds(new Rectangle(76, 9, 152, 21));
        jPanel1.setLayout(null);
        skinCheckBox1.setText("Option One");
        skinCheckBox1.setBounds(new Rectangle(44, 22, 96, 18));
        skinCheckBox2.setBounds(new Rectangle(44, 44, 96, 18));
        skinCheckBox2.setText("Option One");
        skinCheckBox3.setBounds(new Rectangle(44, 66, 96, 18));
        skinCheckBox3.setText("Option One");
        jPanel1.setOpaque(false);
        jPanel2.setOpaque(false);
        jPanel2.setLayout(borderLayout2);
        skinScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        skinScrollPane1.setPreferredSize(new Dimension(300, 400));
        jList1.setOpaque(false);
        jList1.setPreferredSize(new Dimension(270, 500));
        jList1.setFixedCellHeight(18);
        jList1.setFixedCellWidth(-1);
        this.add(skinRaisedPanel1, BorderLayout.NORTH);
        skinRaisedPanel1.add(skinSmallPrompt1, null);
        skinRaisedPanel1.add(jTextField1, null);
        this.add(skinInternalPanel1, BorderLayout.SOUTH);
        skinInternalPanel1.add(skinButton1, null);
        this.add(skinTabbedPane1, BorderLayout.CENTER);
        skinTabbedPane1.add(jPanel1,   "Tab One");
        jPanel1.add(skinCheckBox1, null);
        jPanel1.add(skinCheckBox2, null);
        jPanel1.add(skinCheckBox3, null);
        skinTabbedPane1.add(jPanel2,   "Tab Two");
        jPanel2.add(skinScrollPane1,  BorderLayout.CENTER);
        skinScrollPane1.getViewport().add(jList1, null);
    }

    void skinButton1_actionPerformed(ActionEvent e) {
        System.exit(0);
    }


}

class TestFrame_skinButton1_actionAdapter implements java.awt.event.ActionListener {
    TestFrame adaptee;

    TestFrame_skinButton1_actionAdapter(TestFrame adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.skinButton1_actionPerformed(e);
    }
}
