/**
 * Copyright (c) 2003, David J. Yazel
 *
 * The Magicosm Development Group is granted the rights to
 * use this code in the development of the Magicosm game and all
 * subsequent derrivations in perpetuity.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */
package com.magicosm.skins;

import com.magicosm.skins.renderers.BaseDef;
import com.magicosm.skins.styles.BaseStyle;
import com.magicosm.skins.styles.FrameStyle;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.EmptyBorder;


/**
 * Insert package comments here
 * <p>
 * Originally Coded by David Yazel on Oct 9, 2003 at 8:43:18 PM.
 */
public class SkinFrame extends JPanel implements SkinComponentInterface {
    SkinPainter helper;
    SkinPainter titleHelper = null;

    public void setStyle(Skin skin, BaseStyle style) {
        if (style instanceof FrameStyle) {
            FrameStyle cs = (FrameStyle) style;
            BaseDef background = cs.getBackgroundDef();
            helper = style.getPainter(BaseStyle.STYLE_NORMAL, skin, background);

            if (cs.getTitleDef() != null) {
                titleHelper = style.getPainter(BaseStyle.STYLE_NORMAL, skin,
                        cs.getTitleDef());
            }

            setOpaque(false);
            setBorder(new EmptyBorder(10, 4, 4, 4));
        }
    }

    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        Composite a = g2.getComposite();
        g2.setComposite(AlphaComposite.Src);
        g.setColor(new Color(0, 0, 0, 0));
        g.fillRect(0, 0, getWidth(), getHeight());
        g2.setComposite(a);

        if (helper != null) {
            helper.paint(g, 0, 0, getWidth(), getHeight());
        }

        if (titleHelper != null) {
            titleHelper.paint(g, 17, 0, 60, 11);
        }

        super.paint(g);
        g.dispose();
    }
}
