/**
 * Copyright (c) 2003, David J. Yazel
 *
 * The Magicosm Development Group is granted the rights to
 * use this code in the development of the Magicosm game and all
 * subsequent derrivations in perpetuity.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */
package com.magicosm.skins;

import com.magicosm.skins.styles.BaseStyle;
import com.magicosm.skins.styles.ControlStyle;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.EmptyBorder;


/**
 * Insert package comments here
 * <p>
 * Originally Coded by David Yazel on Oct 12, 2003 at 6:19:46 PM.
 */
public class SkinScrollPane extends JScrollPane
    implements SkinComponentInterface {
    SkinPainter helper;

    public JScrollBar createHorizontalScrollBar() {
        JScrollBar sb = new SkinScrollbar();
        sb.setOrientation(JScrollBar.HORIZONTAL);

        return sb;
    }

    public JScrollBar createVerticalScrollBar() {
        JScrollBar sb = new SkinScrollbar();
        sb.setOrientation(JScrollBar.VERTICAL);

        return sb;
    }

    public void setStyle(Skin skin, BaseStyle style) {
        getViewport().setOpaque(false);
        this.setOpaque(false);
        setViewportBorder(new EmptyBorder(10, 10, 10, 10));
        this.setBorder(null);
        helper = style.getPainter(BaseStyle.STYLE_NORMAL, skin,
                ((ControlStyle) style).getBackgroundDef());
    }

    public void paintComponent(Graphics g) {
        Rectangle b = getViewportBorderBounds();
        Graphics2D g2 = (Graphics2D) g;
        g2.setComposite(AlphaComposite.Src);
        g.setColor(new Color(0, 0, 0, 0));
        g.fillRect(b.x, b.y, b.width, b.height);
        g2.setComposite(AlphaComposite.SrcOver);

        if (helper != null) {
            helper.paint(g, b.x, b.y, b.width + 2, b.height);
        }
    }
}
