/**
 * Copyright (c) 2003, David J. Yazel
 *
 * The Magicosm Development Group is granted the rights to
 * use this code in the development of the Magicosm game and all
 * subsequent derrivations in perpetuity.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */
package com.magicosm.skins;

import com.magicosm.skins.styles.BaseStyle;

import java.io.IOException;

import java.util.HashMap;
import java.util.Map;

import javax.swing.text.Style;


/**
 * A Theme holds mappings from classes to styles
 * <p>
 * Originally Coded by David Yazel on Oct 9, 2003 at 8:09:49 PM.
 */
public class Theme implements SkinNodeInterface {
    String name;
    String extendsThemeName;
    Theme extendsTheme;
    Map map = new HashMap();

    public Theme(String name, String extendsThemeName) {
        this.name = name;
        this.extendsThemeName = extendsThemeName;
    }

    public void add(Skin skin, String className, String styleName)
        throws Exception {
        BaseStyle style = skin.getStyle(styleName);

        if (style == null) {
            throw new Exception("Unknown style : " + styleName);
        }

        map.put(className, style);
    }

    public String getName() {
        return name;
    }

    public void validateAndLoad(Skin skin) throws IOException {
        if (extendsThemeName != null) {
            extendsTheme = skin.getTheme(extendsThemeName);

            if (extendsTheme == null) {
                throw new IOException("No such theme : " + extendsThemeName);
            }
        }
    }
}
