/**
 * Copyright (c) 2003, David J. Yazel
 *
 * The Magicosm Development Group is granted the rights to
 * use this code in the development of the Magicosm game and all
 * subsequent derrivations in perpetuity.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */
package com.magicosm.skins.renderers;

import com.magicosm.skins.Skin;
import com.magicosm.skins.SkinNodeInterface;

import java.io.IOException;


/**
 * <p>
 * Originally Coded by David Yazel on Oct 6, 2003 at 1:42:11 PM.
 */
public class BoxDef extends BaseDef implements SkinNodeInterface {
    String name;
    String imageFile;
    String imageDisableFile;
    String imageHighlightFile;
    boolean stretch;

    public String getImageFile() {
        return imageFile;
    }

    public void setImageFile(String imageFile) {
        this.imageFile = imageFile;
    }

    public String getImageDisableFile() {
        return imageDisableFile;
    }

    public void setImageDisableFile(String imageDisableFile) {
        this.imageDisableFile = imageDisableFile;
    }

    public String getImageHighlightFile() {
        return imageHighlightFile;
    }

    public void setImageHighlightFile(String imageHighlightFile) {
        this.imageHighlightFile = imageHighlightFile;
    }

    public String getName() {
        return name;
    }

    public boolean isStretch() {
        return stretch;
    }

    public void setStretch(boolean stretch) {
        this.stretch = stretch;
    }

    public void validateAndLoad(Skin skin) throws IOException {
        check(name != null, "Name");
        check(imageFile != null, "image");

        //        check(imageDisableFile != null,"imageDisable");
        //        check(imageHighlightFile != null,"imageHighlight");
        skin.loadImage(imageFile);

        if (imageDisableFile != null) {
            skin.loadImage(imageDisableFile);
        }

        if (imageHighlightFile != null) {
            skin.loadImage(imageHighlightFile);
        }
    }

    public void setName(String name) {
        this.name = name;
    }
}
