/**
 * Copyright (c) 2003, David J. Yazel
 *
 * The Magicosm Development Group is granted the rights to
 * use this code in the development of the Magicosm game and all
 * subsequent derrivations in perpetuity.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */
package com.magicosm.skins.renderers;

import com.magicosm.skins.Skin;
import com.magicosm.skins.SkinNodeInterface;

import java.io.IOException;


/**
 * <p>
 * Originally Coded by David Yazel on Oct 6, 2003 at 1:42:11 PM.
 */
public class MaskedBoxDef extends BaseDef implements SkinNodeInterface {
    String name;
    String borderFile;
    String borderMaskFile;
    String centerFile;
    String centerDisableFile;
    String centerHighlightFile;
    String borderDisableFile;
    int cornerSize = -1;

    public String getBorderFile() {
        return borderFile;
    }

    public void setBorderFile(String borderFile) {
        this.borderFile = borderFile;
    }

    public String getBorderMaskFile() {
        return borderMaskFile;
    }

    public void setBorderMaskFile(String borderMaskFile) {
        this.borderMaskFile = borderMaskFile;
    }

    public String getCenterFile() {
        return centerFile;
    }

    public void setCenterFile(String centerFile) {
        this.centerFile = centerFile;
    }

    public String getCenterDisableFile() {
        return centerDisableFile;
    }

    public void setCenterDisableFile(String centerDisableFile) {
        this.centerDisableFile = centerDisableFile;
    }

    public String getCenterHighlightFile() {
        return centerHighlightFile;
    }

    public void setCenterHighlightFile(String centerHighlightFile) {
        this.centerHighlightFile = centerHighlightFile;
    }

    public String getBorderDisableFile() {
        return borderDisableFile;
    }

    public void setBorderDisableFile(String borderDisableFile) {
        this.borderDisableFile = borderDisableFile;
    }

    public int getCornerSize() {
        return cornerSize;
    }

    public void setCornerSize(int cornerSize) {
        this.cornerSize = cornerSize;
    }

    public String getName() {
        return name;
    }

    public void validateAndLoad(Skin skin) throws IOException {
        check(name != null, "Name");
        check(borderFile != null, "border");
        check(borderDisableFile != null, "mask");
        check(borderMaskFile != null, "mask");
        check(centerFile != null, "centerNormal");
        check(centerDisableFile != null, "centerDisable");
        check(centerHighlightFile != null, "centerHighlight");
        check(cornerSize != -1, "maskCorner");

        skin.loadImage(borderFile);
        skin.loadImage(borderDisableFile);
        skin.loadImage(borderMaskFile);
        skin.loadImage(centerFile);
        skin.loadImage(centerDisableFile);
        skin.loadImage(centerHighlightFile);
    }

    public void setName(String name) {
        this.name = name;
    }
}
