/**
 * Copyright (c) 2003, David J. Yazel
 *
 * The Magicosm Development Group is granted the rights to
 * use this code in the development of the Magicosm game and all
 * subsequent derrivations in perpetuity.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) A
 * RISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE
 *
 */
package com.magicosm.skins.styles;

import com.magicosm.skins.Skin;
import com.magicosm.skins.SkinNodeInterface;
import com.magicosm.skins.renderers.BaseDef;

import java.io.IOException;


/**
 * Insert package comments here
 * <p>
 * Originally Coded by David Yazel on Oct 12, 2003 at 1:27:36 PM.
 */
public class ScrollbarStyle extends BaseStyle implements SkinNodeInterface {
    String name;
    String vtrough;
    String htrough;
    String vthumb;
    String hthumb;
    String up;
    String down;
    String left;
    String right;
    BaseDef vtroughDef;
    BaseDef htroughDef;
    BaseDef vthumbDef;
    BaseDef hthumbDef;
    BaseDef rightDef;
    BaseDef leftDef;
    BaseDef upDef;
    BaseDef downDef;

    public BaseDef getRightDef() {
        return rightDef;
    }

    public void setRightDef(BaseDef rightDef) {
        this.rightDef = rightDef;
    }

    public BaseDef getLeftDef() {
        return leftDef;
    }

    public void setLeftDef(BaseDef leftDef) {
        this.leftDef = leftDef;
    }

    public BaseDef getUpDef() {
        return upDef;
    }

    public void setUpDef(BaseDef upDef) {
        this.upDef = upDef;
    }

    public BaseDef getDownDef() {
        return downDef;
    }

    public void setDownDef(BaseDef downDef) {
        this.downDef = downDef;
    }

    public String getUp() {
        return up;
    }

    public void setUp(String up) {
        this.up = up;
    }

    public String getDown() {
        return down;
    }

    public void setDown(String down) {
        this.down = down;
    }

    public String getLeft() {
        return left;
    }

    public void setLeft(String left) {
        this.left = left;
    }

    public String getRight() {
        return right;
    }

    public void setRight(String right) {
        this.right = right;
    }

    public BaseDef getHtroughDef() {
        return htroughDef;
    }

    public void setHtroughDef(BaseDef htroughDef) {
        this.htroughDef = htroughDef;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getVtrough() {
        return vtrough;
    }

    public void setVtrough(String vtrough) {
        this.vtrough = vtrough;
    }

    public String getHtrough() {
        return htrough;
    }

    public void setHtrough(String htrough) {
        this.htrough = htrough;
    }

    public String getVthumb() {
        return vthumb;
    }

    public void setVthumb(String vthumb) {
        this.vthumb = vthumb;
    }

    public String getHthumb() {
        return hthumb;
    }

    public void setHthumb(String hthumb) {
        this.hthumb = hthumb;
    }

    public BaseDef getVtroughDef() {
        return vtroughDef;
    }

    public void setVtroughDef(BaseDef vtroughDef) {
        this.vtroughDef = vtroughDef;
    }

    public BaseDef getHtoughDef() {
        return htroughDef;
    }

    public void setHtoughDef(BaseDef htoughDef) {
        this.htroughDef = htoughDef;
    }

    public BaseDef getVthumbDef() {
        return vthumbDef;
    }

    public void setVthumbDef(BaseDef vthumbDef) {
        this.vthumbDef = vthumbDef;
    }

    public BaseDef getHthumbDef() {
        return hthumbDef;
    }

    public void setHthumbDef(BaseDef hthumbDef) {
        this.hthumbDef = hthumbDef;
    }

    public void validateAndLoad(Skin skin) throws IOException {
        vtroughDef = getRenderer(skin, "vtrough", vtrough);
        htroughDef = getRenderer(skin, "htrough", htrough);
        vthumbDef = getRenderer(skin, "vthumb", vthumb);
        hthumbDef = getRenderer(skin, "hthumb", hthumb);
        rightDef = getRenderer(skin, "right", right);
        leftDef = getRenderer(skin, "left", left);
        upDef = getRenderer(skin, "up", up);
        downDef = getRenderer(skin, "down", down);
    }
}
